import { AdapterBase } from '@feathersjs/adapter-commons';
import type { PaginationOptions } from '@feathersjs/adapter-commons';
import type { SequelizeAdapterOptions, SequelizeAdapterParams } from './declarations';
import type { Id, NullableId, Paginated, Query } from '@feathersjs/feathers';
import type { FindOptions } from 'sequelize';
export declare class SequelizeAdapter<Result, Data = Partial<Result>, ServiceParams extends SequelizeAdapterParams = SequelizeAdapterParams, PatchData = Partial<Data>> extends AdapterBase<Result, Data, PatchData, ServiceParams, SequelizeAdapterOptions> {
    constructor(options: SequelizeAdapterOptions);
    get raw(): boolean;
    get Op(): any;
    get Model(): import("sequelize").ModelStatic<any>;
    getModel(_params?: ServiceParams): import("sequelize").ModelStatic<any>;
    /**
     * @deprecated use 'service.ModelWithScope' instead. 'applyScope' will be removed in a future release.
     */
    applyScope(params?: ServiceParams): import("sequelize").ModelStatic<any>;
    ModelWithScope(params: ServiceParams): import("sequelize").ModelStatic<any>;
    convertOperators(q: any): Query;
    filterQuery(params: ServiceParams): {
        filters: {
            [key: string]: any;
        };
        query: Query;
        paginate: import("@feathersjs/adapter-commons").PaginationParams;
    };
    paramsToAdapter(id: NullableId, _params?: ServiceParams): FindOptions;
    /**
     * returns either the model instance / jsonified object for an id or all unpaginated
     * items for `params` if id is null
     */
    _getOrFind(id: Id, _params?: ServiceParams): Promise<Result>;
    _getOrFind(id: null, _params?: ServiceParams): Promise<Result[]>;
    _find(params?: ServiceParams & {
        paginate?: PaginationOptions;
    }): Promise<Paginated<Result>>;
    _find(params?: ServiceParams & {
        paginate: false;
    }): Promise<Result[]>;
    _find(params?: ServiceParams): Promise<Paginated<Result> | Result[]>;
    _get(id: Id, params?: ServiceParams): Promise<Result>;
    _create(data: Data, params?: ServiceParams): Promise<Result>;
    _create(data: Data[], params?: ServiceParams): Promise<Result[]>;
    _create(data: Data | Data[], params?: ServiceParams): Promise<Result | Result[]>;
    _patch(id: null, data: PatchData, params?: ServiceParams): Promise<Result[]>;
    _patch(id: Id, data: PatchData, params?: ServiceParams): Promise<Result>;
    _update(id: Id, data: Data, params?: ServiceParams): Promise<Result>;
    _remove(id: null, params?: ServiceParams): Promise<Result[]>;
    _remove(id: Id, params?: ServiceParams): Promise<Result>;
}
